local MODNAME = "ReadyCheckReminder"
local ACTIVATED_ICON = "Interface\\Icons\\Inv_scroll_10"
local DEACTIVATED_ICON = "Interface\\Icons\\Inv_scroll_05"

local addon = LibStub( "AceAddon-3.0" ):NewAddon( MODNAME, "AceEvent-3.0", "AceConsole-3.0" )

addon:RegisterChatCommand("rrm", "SlashProcessorFunc")

local AceGUI = LibStub("AceGUI-3.0")

local LSM = LibStub("LibSharedMedia-3.0")

local defaults = {
  profile = {
    setting = true,
  }
}

local moverBackdrop = {
  bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
}


local smFrame, titleFrame = "rrSMF","rrTitle"

local smf, title

function addon:OnInitialize()

    self.data = LibStub("AceDB-3.0"):New("rrData", defaults)

    self.db = self.data.profile

    if self.db.diag_text==nil then self.db.diag_text = "" end

    if self.db.font_path==nil then self.db.font_path = "Fonts\\ARIALN.TTF" end
	
	if self.db.font_size == nil then self.db.font_size = 11 end
	
	if self.db.msg_x_offset == nil then self.db.msg_x_offset = 0 end

	if self.db.msg_y_offset == nil then self.db.msg_y_offset = 0 end
	
	if self.db.msg_point == nil then self.db.msg_point = "CENTER" end
	
	if self.db.msg_box_width == nil then self.db.msg_box_width = 200 end
	
	if self.db.msg_box_height==nil then self.db.msg_box_height = 100 end

	mainFrame = CreateFrame("Frame","rrMain",UIParent)

	mainFrame:EnableMouse(false)
	mainFrame:SetMovable(false)
	mainFrame:SetResizable(false)
	mainFrame:SetFrameStrata("LOW")
	mainFrame:SetMinResize(200, 100)
	mainFrame:SetToplevel(true)
	mainFrame:SetScript("OnHide", function(self) addon:Frame_OnClose(self) end)
	mainFrame:SetScript("OnMouseDown", function(self) addon:Frame_OnMouseDown(self) end)

    mainFrame:SetWidth(self.db.msg_box_width) -- Set these to whatever height/width is needed 
    mainFrame:SetHeight(self.db.msg_box_height) -- for your Texture

    mainFrame:SetPoint(self.db.msg_point,self.db.msg_x_offset,self.db.msg_y_offset)

	mainFrame:Show()

	title = CreateFrame("Frame",titleFrame,mainFrame)
	title:SetScript("OnMouseDown", function(self) addon:Title_OnMouseDown(self) end)
	title:SetScript("OnMouseUp", function(self) addon:MoverSizer_OnMouseUp(self) end)
	title:SetPoint("TOP", mainFrame, "TOP", 0, 0)
	title:SetWidth(100)
	title:SetHeight(50)
	title:SetFrameStrata("HIGH")

	
	local titletext = title:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	titletext:SetPoint("TOP", mainFrame, "TOP", 0, 0)
    titletext:SetText("MoveMe")

    smf = CreateFrame("ScrollingMessageFrame",smFrame,mainFrame)

 	smf:SetAllPoints()
    smf:SetJustifyH("LEFT")
    smf:SetMaxLines(30)
    smf:SetFading(true)
    smf:SetFadeDuration(3)
    smf:SetTimeVisible(30)
    smf:SetFrameStrata("MEDIUM")

	sizer_se = CreateFrame("Frame", nil, mainFrame)
	sizer_se:SetPoint("BOTTOMRIGHT")
	sizer_se:SetBackdropColor(1,1,1,.5)
	sizer_se:SetWidth(25)
	sizer_se:SetHeight(25)
	sizer_se:EnableMouse()
	sizer_se:SetScript("OnMouseDown", function(self) addon:SizerSE_OnMouseDown(self) end)
	sizer_se:SetScript("OnMouseUp", function(self) addon:MoverSizer_OnMouseUp(self) end)
	

	
	local line1 = sizer_se:CreateTexture(nil, "BACKGROUND")
	line1:SetWidth(14)
	line1:SetHeight(14)
	line1:SetPoint("BOTTOMRIGHT", -6, 6)
	line1:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	local x = 0.1 * 14/17
	line1:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

	local line2 = sizer_se:CreateTexture(nil, "BACKGROUND")
	line2:SetWidth(8)
	line2:SetHeight(8)
	line2:SetPoint("BOTTOMRIGHT", -6, 6)
	line2:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	local x = 0.1 * 8/17
	line2:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)
	
    mainFrame:SetMovable(false)
	mainFrame:SetResizable(false)
    mainFrame:EnableMouse(false)
    
    mainFrame:SetBackdrop(nil)
    	
	
	title:Hide()
	sizer_se:Hide()	
	
	
	self:RegisterEvent("READY_CHECK", "ShowPrompt")
end

function addon:SizerSE_OnMouseDown(frame)
	frame:GetParent():StartSizing("BOTTOMRIGHT")
	AceGUI:ClearFocus()
end

function addon:Title_OnMouseDown(frame)
  if frame:GetParent():IsMovable() then
	frame:GetParent():StartMoving()
	AceGUI:ClearFocus()
  end
end

function addon:MoverSizer_OnMouseUp(mover)
	local frame = mover:GetParent()
	frame:StopMovingOrSizing()
	
	addon:SavePoint()
	
	self.db.msg_box_width = frame:GetWidth()
	self.db.ms_box_height = frame:GetHeight()

end

function addon:Frame_OnClose(frame)
	--frame.obj:Fire("OnClose")
end

function addon:Frame_OnMouseDown(frame)
	AceGUI:ClearFocus()
end


function addon:ToggleMoveMessageFrame(flag)
  if flag == true then
    mainFrame:SetMovable(true)
	mainFrame:SetResizable(true)
    mainFrame:EnableMouse(true)
    
    mainFrame:SetBackdrop(moverBackdrop)
    
    title:Show()
    sizer_se:Show()
   else
   
    mainFrame:SetMovable(false)
	mainFrame:SetResizable(false)
    mainFrame:EnableMouse(false)
    
    mainFrame:SetBackdrop(nil)
    
    title:Hide()
    sizer_se:Hide()
      	 
   end
end

function addon:SavePoint()

	local point, relFrame, relPoint, xOffset, yOffset = mainFrame:GetPoint()
	self.db.msg_x_offset = xOffset
	self.db.msg_y_offset = yOffset
	self.db.msg_point = point
			
end

function addon:SlashProcessorFunc(input)
  -- Process the slash command ('input' contains whatever follows the slash command)
  addon:ShowMenu()
end

function addon:ShowPrompt()

    local _, instanceType, difficulty, _, maxPlayers, playerDifficulty, isDynamicInstance = GetInstanceInfo()
    local lfr=0
    if IsPartyLFG() and IsInLFGDungeon() and difficulty == 2 and instanceType == "raid" and maxPlayers == 25 then
      lfr=1
    end

	if lfr==0 then	
	
	 smf:SetFont(self.db.font_path, self.db.font_size)
	 
	 smf:Clear()
	 
	 local entries = { strsplit(",",self.db.diag_text) }
	 
	 for i,v in pairs(entries) do
	  if #v > 0 then 
        smf:AddMessage(strconcat(i, " ", v))
      end
	 end

	end
end

function addon:ShowMenu()

-- Create a container frame
	local f = AceGUI:Create("Frame",nil,UIParent)
	f:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
	f:SetTitle("Ready Check Reminder Options")
	--f:SetStatusText("Status Bar")
	f:SetLayout("Flow")

--Edit Box
	local editbox = AceGUI:Create("EditBox")
	editbox:SetLabel("Ready Check Text:")
	editbox:SetText(self.db.diag_text)
	editbox:SetWidth(500)
	editbox:SetCallback("OnEnterPressed", function(widget, event, text) self.db.diag_text = text end)
	f:AddChild(editbox)

    local fontGroup = AceGUI:Create("InlineGroup")
	fontGroup:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
    fontGroup:SetTitle("Font Settings")
    fontGroup:SetFullWidth(true)
	fontGroup:SetLayout("Flow")
    


--Font Dropdown
	local fonts = LSM:HashTable("font")

-- If you're using AceGUI-3.0 directly;
	local dropdown = AceGUI:Create("LSM30_Font")
	--dropdown:SetLabel("Font")
	dropdown:SetList(fonts, nil)
	dropdown:SetCallback("OnValueChanged", function(info,event, value)
		self.db.font_path = fonts[value]
		dropdown:SetValue(value)
	end)

--Set Default
	for i, v in pairs(fonts) do
		if v == self.db.font_path then
			dropdown:SetValue(i)
			break
		end
	end

	fontGroup:AddChild(dropdown)

	local fontSize = AceGUI:Create("EditBox")
	fontSize:SetText(self.db.font_size)
	fontSize:SetWidth(135)
	fontSize:SetCallback("OnEnterPressed", function(widget, event, text) self.db.font_size = text end)
	
	fontGroup:AddChild(fontSize)
	
	local colorPicker = AceGUI:Create("ColorPicker")
	colorPicker:SetCallback("OnValueChanged", function(r,g,b,a) 
		colorPicker:SetColor(r,g,b,a)
	end)
	colorPicker:SetCallback("OnValueConfirmed", function(this, event, r,g,b,a) 
		smf:SetTextColor(r,g,b,a)
		self.db.color.r = r
		self.db.color.g = g
		self.db.color.b = b
		self.db.color.a = a
	end)
	
	
	fontGroup:AddChild(colorPicker)
	
	f:AddChild(fontGroup)

	local button = AceGUI:Create("Button")
	button:SetText("Test")
	button:SetCallback("OnClick",function() addon:ShowPrompt() end)
	
	f:AddChild(button)
	
	local unlockButton = AceGUI:Create("Button")
	unlockButton:SetText("UnLock")
	unlockButton:SetCallback("OnClick",function() addon:ToggleMoveMessageFrame(true) end)
	
	f:AddChild(unlockButton)

	local lockButton = AceGUI:Create("Button")
	lockButton:SetText("Lock")
	lockButton:SetCallback("OnClick",function() addon:ToggleMoveMessageFrame(false) end)
	
	f:AddChild(lockButton)

	
end